> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List Preferences

> Lists all user preferences.

`Unary` · [`Users`](/docs/api-reference/generated/user/overview)

Lists all user preferences.

Use this method to:

* View all user settings
* Export preferences
* Audit configurations

### Examples

* List preferences:

  Shows all preferences with pagination.

  ```yaml theme={null}
  pagination:
    pageSize: 20
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.UserService/ListPreferences
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.UserService/ListPreferences" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "pagination": {
      "pageSize": 1
    }
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.pagination_pb2 as pagination_pb2
  import gitpod.v1.user_pb2 as user_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = user_pb2.ListPreferencesRequest(
      pagination=pagination_pb2.PaginationRequest(
          page_size=1,
      ),
  )
  response = ona.services.user.list_preferences(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ListPreferencesRequestSchema } from "@gitpod/sdk/gitpod/v1/user_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(ListPreferencesRequestSchema, {
      pagination: {
        pageSize: 1,
      },
    });
    const response = await ona.services.user.listPreferences(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.ListPreferencesRequest{
  		Pagination: &gitpodpb.PaginationRequest{
  			PageSize: 1,
  		},
  	})
  	response, err := ona.Services.User.ListPreferences(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "pagination": {
      "pageSize": 1
    }
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.ListPreferencesRequest`

| Field        | Type                                                    | Required | Description |
| ------------ | ------------------------------------------------------- | -------- | ----------- |
| `pagination` | [PaginationRequest](#type-gitpod-v1-pagination-request) | No       |             |

## Response

`gitpod.v1.ListPreferencesResponse`

| Field         | Type                                                       | Required | Description |
| ------------- | ---------------------------------------------------------- | -------- | ----------- |
| `pagination`  | [PaginationResponse](#type-gitpod-v1-pagination-response)  | No       |             |
| `preferences` | array of [UserPreference](#type-gitpod-v1-user-preference) | No       |             |

## Related types

<a id="type-gitpod-v1-pagination-request" />

<Accordion title="PaginationRequest">
  `gitpod.v1.PaginationRequest`

  | Field      | Type    | Required | Description                                                                                                                              |
  | ---------- | ------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
  | `pageSize` | integer | No       | Page size is the maximum number of results to retrieve per page. Defaults to 25. Maximum 100. Constraints: `int32.gte=0, int32.lte=100`. |
  | `token`    | string  | No       | Token for the next set of results that was returned as next\_token of a PaginationResponse                                               |
</Accordion>

<a id="type-gitpod-v1-pagination-response" />

<Accordion title="PaginationResponse">
  `gitpod.v1.PaginationResponse`

  | Field       | Type   | Required | Description                                                                             |
  | ----------- | ------ | -------- | --------------------------------------------------------------------------------------- |
  | `nextToken` | string | No       | Token passed for retrieving the next set of results. Empty if there are no more results |
</Accordion>

<a id="type-gitpod-v1-user-preference" />

<Accordion title="UserPreference">
  `gitpod.v1.UserPreference`

  | Field       | Type               | Required | Description                                                                                                                                                                   |
  | ----------- | ------------------ | -------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
  | `key`       | string             | No       | Constraints: `string.max_len=255, string.min_len=1`.                                                                                                                          |
  | `value`     | string             | No       | omitting value field will cause an error due to min\_len validation, to unset a preference use DeletePreference instead Constraints: `string.max_len=2480, string.min_len=1`. |
  | `id`        | string             | No       | Constraints: `string.uuid=true`.                                                                                                                                              |
  | `createdAt` | RFC 3339 timestamp | No       |                                                                                                                                                                               |
  | `updatedAt` | RFC 3339 timestamp | No       |                                                                                                                                                                               |
</Accordion>
